version: '3.8'

services:
  {{ docker_compose_app_container_name }}:
    container_name: {{ docker_compose_app_container_name }}
    image: {{ docker_compose_image_app }}
    restart: always
    env_file: env.docker-compose
    depends_on:
      {{ docker_compose_mysql_container_name }}:
        condition: service_healthy
    environment:
      MYSQL_HOST: {{ docker_compose_mysql_container_name }}
    networks:
      - traefik
      - {{ docker_compose_app_network_name }}
    labels:
      - "traefik.enable=true"
      - "traefik.http.routers.{{ docker_compose_app_container_name }}.rule=Host(`{{ docker_compose_virtual_host_app }}`)"
      - "traefik.http.routers.{{ docker_compose_app_container_name }}.entrypoints=websecure"
      - "traefik.http.routers.{{ docker_compose_app_container_name }}.tls.certresolver=myresolver"
      - "traefik.http.routers.{{ docker_compose_app_container_name }}.middlewares=traefik-compress"
      - "traefik.http.services.{{ docker_compose_app_container_name }}.loadbalancer.server.port=3000"

  {{ docker_compose_mysql_container_name }}:
    container_name: {{ docker_compose_mysql_container_name }}
    image: mysql:8.0
    restart: always
    env_file: env.docker-compose
    healthcheck:
      test: ["CMD", "mysqladmin", "ping", "-h", "localhost"]
      interval: 10s
      timeout: 5s
      retries: 3
    volumes:
      - {{ docker_compose_volume_name }}:/var/lib/mysql/
    expose:
      - 3306
    networks:
      - {{ docker_compose_app_network_name }}

networks:
  traefik:
    external: true
    name: traefik
  {{ docker_compose_app_network_name }}:
    driver: bridge
    name: {{ docker_compose_app_network_name }}

volumes:
  {{ docker_compose_volume_name }}:
    name: {{ docker_compose_volume_name }}
    driver: local